/*
*jQuery sliderrr v1.0
*http://zxcvbnmnbvcxz.com
*
*Copyright 2013, kenta toshikura
*
*the MIT license.
*http://www.opensource.org/licenses/mit-license.php 
*/

;(function($) {
    $.fn.sliderrr = function(option) {
        var element=this;
        var options = $.extend({
            ease         : 'ease',
            auto         : false,
            interval     : 3000,
            perspective  : 1000,
            key          : true,
            eachspeed    : true,
            speed        : 500,
            control      : true,
            responsive   : false,
            selector     : '#container',
            prev         : '<',
            next         : '>',
            slideprev    : '#prevbtn',
            slidenext    : '#nextbtn'
        }, option);

        $.support.transform  = typeof $("body").css("transform") === "string";
        $.support.transition = typeof $("body").css("transitionProperty") === "string";
        var sliderrr = $(element),nextbtn = $(options.slidenext),prevbtn = $(options.slideprev),ease = options.ease;

        setup();

        if(options.responsive){
            var timer = false;
            $(window).resize(function() {
                if (timer !== false) {
                    clearTimeout(timer);
                }
                timer = setTimeout(function() {
                    setup('resizer');
                },200);
            });
        }

        function setup(rhandle){
            sliderrr.each(function(){
                var slider = $(this).children(),last = slider.last(),first = slider.first(),vnum = slider.size(),mode = $(this).data('animate')||'slide';

                if(options.responsive){
                    slideBdW = $(options.selector).width();
                }else{
                    slideBdW = $(this).width();
                }

                slideBdH = $(this).height();

                if(mode == 'slide'){
                    slider.css({
                        'float':'left',
                        'overflow':'hidden',
                        'display':'block',
                        'height':slideBdH,
                        'width':slideBdW
                    });

                    if(rhandle !== 'resizer'){
                        if(vnum == 2){
                            last.clone().appendTo(this);
                            first.clone().appendTo(this);
                            vnum = 4;
                        }
                        $(this).prepend(last);
                    }

                    $(this).css({
                        'clear':'both',
                        'position':'absolute',
                        'left':-slideBdW,
                        'width':parseInt(slideBdW*vnum)
                    });

                }else if(mode == 'fade' || mode == 'flip'){
                    slider.css({
                        'position':'absolute',
                        'overflow':'hidden',
                        'display':'block',
                        'height':slideBdH,
                        'width':slideBdW
                    });

                    var list = slider.toArray().reverse();
                    $(this).empty().append(list);
                    if(mode == 'fade'){
                        $(this).css({
                            'clear':'both',
                            'position':'relative',
                            'left':0,
                            'width':slideBdW
                        });
                    }else{
                        $(this).css({
                            'clear':'both',
                            'position':'relative',
                            'perspective':options.perspective,
                            'left':0,
                            'width':slideBdW
                        });
                    }

                }

                if(rhandle == 'resizer'){
                    $('.slideArea').css({'width':slideBdW});
                }else{
                    if(mode == 'flip'){
                        $(this).wrap('<div class="slideArea" style="position:relative; width:' + slideBdW + 'px; height:'+slideBdH+'px "></div>');
                    }else{
                        $(this).wrap('<div class="slideArea" style="overflow:hidden; position:relative; width:' + slideBdW + 'px; height:'+slideBdH+'px "></div>');
                    }
                    if(options.control){
                        $(this).parent().append('<ul class="sr-pager"></ul>');
                        $(this).parent().find('.sr-pager').append('<li class="sr-prev"><a>'+options.prev+'</a></li>');
                        $(this).parent().find('.sr-pager').append('<li class="sr-next"><a>'+options.next+'</a></li>');
                    }else{
                        if($(this).data('local-control')){
                            $(this).parent().append('<ul class="sr-pager"></ul>');
                            $(this).parent().find('.sr-pager').append('<li class="sr-prev"><a>'+options.prev+'</a></li>');
                            $(this).parent().find('.sr-pager').append('<li class="sr-next"><a>'+options.next+'</a></li>');
                        }
                    }
                }

            });
        }


        if(options.auto){
            setInterval(function(){
                if($.support.transition){gonextTran(); }else{gonext(); }
            },3000);
        }

        function animatenext(num,sa,slider,speed,slideWidth,mode){
            if(num > 2){
                if($.support.transition){
                    if(mode == 'slide'){
                        if(!sa.is('.na')){
                            sa.addClass('na').css({
                                'left' : parseInt(sa.css('left'))-slideWidth+'px','transition':'left '+speed/1000+'s '+ease
                            });
                            var fst = sa.children().first();
                            sa.one('oTransitionEnd mozTransitionEnd webkitTransitionEnd transitionend',function(){
                                fst.appendTo(sa);
                                sa.removeClass('na').css({'left': -slideWidth+'px','transition-duration':'0s'});
                            });
                        }
                    }else if(mode == 'fade'){
                        slider.last().css({'opacity' :0,'transition':'opacity '+speed/1000+'s '+ease});
                        slider.last().one('oTransitionEnd mozTransitionEnd webkitTransitionEnd transitionend',function(){
                            slider.last().prependTo(sa);
                            slider.first().css({'opacity':1,'transition-duration':'0s'});
                        });
                    }else if(mode == 'flip'){
                        slider.last().css({'transform-origin':'center center','transition':'all 0s'});
                        slider.last().css({'transform':'rotateY(90deg)','transform-origin':'center center','transition':'all '+speed/1000+'s '+ease});
                        slider.last().one('oTransitionEnd mozTransitionEnd webkitTransitionEnd transitionend',function(){
                            slider.last().prependTo(sa);
                            slider.first().css({'transform':'rotateY(0deg)','transform-origin':'center center','transition':'all 0s'});
                        });
                    }
                }else{
                    if(mode == 'slide'){
                        sa.not(':animated').animate({
                            'left' : parseInt(sa.css('left'))-slideWidth+'px'
                        },speed,
                        function(){
                            sa.css('left',-slideWidth); sa.children().first().appendTo(sa);
                        });
                    }else if(mode == 'fade' || mode == 'flip'){
                        slider.last().not(':animated').animate({'opacity':0},speed,
                        function(){
                            slider.first().css({'opacity':1}); slider.last().prependTo(sa);
                        });
                    }
                }
            }
        }

        function animateprev(num,sa,slider,speed,slideWidth,mode){
            if(num > 2){
                if($.support.transition){
                    if(mode == 'slide'){
                        if(!sa.is('.na')){
                            sa.addClass('na').css({
                                'left' : parseInt(sa.css('left'))+slideWidth+'px','transition':'left '+speed/1000+'s '+ease
                            });
                            var fst = sa.children().last();
                            sa.one('oTransitionEnd mozTransitionEnd webkitTransitionEnd transitionend',function(){
                                fst.prependTo(sa);
                                sa.removeClass('na').css({'left': -slideWidth+'px','transition-duration':'0s'});
                            });
                        }
                    }else if(mode == 'fade'){
                        slider.first().css({'opacity' :1,'transition-duration':'0s'});
                        slider.not(':first').css({'opacity' :0,'transition':'opacity '+speed/1000+'s '+ease});
                        slider.not(':first').one('oTransitionEnd mozTransitionEnd webkitTransitionEnd transitionend',function(){
                            slider.not(':first').prependTo(sa);
                            slider.not(':first').css({'opacity':1,'transition-duration':'0s'});
                        });
                    }else if(mode == 'flip'){
                        slider.first().css({'transform':'rotateY(0deg)','transform-origin':'center center','transition':'all 0s'});
                        slider.not(':first').css({'transform':'rotateY(-90deg)','transform-origin':'center center','transition':'all '+speed/1000+'s '+ease});
                        slider.not(':first').one('oTransitionEnd mozTransitionEnd webkitTransitionEnd transitionend',function(){
                            slider.not(':first').prependTo(sa);
                            slider.not(':first').css({'transform':'rotateY(0deg)','transform-origin':'center center','transition':'all 0s'});
                        });
                    }

                }else{
                    if(mode == 'slide'){
                        sa.not(':animated').animate({
                            'left' : parseInt(sa.css('left'))+slideWidth+'px'
                        },speed,
                        function(){
                            sa.children().last().prependTo(sa);sa.css('left',-slideWidth+'px');
                        });
                    }else if(mode == 'fade' || mode == 'flip'){
                        slider.first().css({'opacity' :1,'transition-duration':'0s'});
                        slider.not(':first').animate({'opacity' :0},speed,function(){
                            slider.not(':first').prependTo(sa);
                            slider.not(':first').css({'opacity':1});
                        });
                    }
                }

            }
        }


        $(document).on('click', '.sr-next', function() {
            var target = $(this).parent('.sr-pager').prev();
            var sa = target,slider = sa.children(),num = slider.size(),slideW = sa.width(),slideWidth = parseInt(slideW/num),mode = sa.data('animate')||'slide';
            if(options.eachspeed){if(Number(sa.data('speed'))){var speed  = Number(sa.data('speed')); }else{var speed  = options.speed; }}else{var speed  = options.speed;}
            animatenext(num,sa,slider,speed,slideWidth,mode);
        });

        $(document).on('click', '.sr-prev', function() {
            var target = $(this).parent('.sr-pager').prev();
            var sa = target,slider = sa.children(),num = slider.size(),slideW = sa.width(),slideWidth = parseInt(slideW/num),mode = sa.data('animate')||'slide';
            if(options.eachspeed){if(Number(sa.data('speed'))){var speed  = Number(sa.data('speed')); }else{var speed  = options.speed; }}else{var speed  = options.speed;}
            animateprev(num,sa,slider,speed,slideWidth,mode);
        });

        if(options.key){
            $(document).keydown(function(e){
                if(e.keyCode == 39){gonextTran();}
                if(e.keyCode == 37){goprevTran();}
            });
        }

        nextbtn.click(function(){
            gonextTran();
        });

        prevbtn.click(function(){
            goprevTran();
        });

        function gonextTran(){
            sliderrr.each(function(){
                var sa = $(this),slider = sa.children(),num = slider.size(),slideW = sa.width(),slideWidth = parseInt(slideW/num),mode = sa.data('animate')||'slide';
                if(options.eachspeed){if(Number(sa.data('speed'))){var speed  = Number(sa.data('speed')); }else{var speed  = options.speed; }}else{var speed  = options.speed;}
                animatenext(num,sa,slider,speed,slideWidth,mode);
            });
        }

        function goprevTran(){
            sliderrr.each(function(){
                var sa = $(this),speed  = sa.data('speed'),slider = sa.children(),num = slider.size(),slideW = sa.width(),slideWidth = parseInt(slideW/num),mode = sa.data('animate')||'slide';
                if(options.eachspeed){if(Number(sa.data('speed'))){var speed  = Number(sa.data('speed')); }else{var speed  = options.speed; }}else{var speed  = options.speed;}
                animateprev(num,sa,slider,speed,slideWidth,mode);
            });
        }

        return element;
    };
})(jQuery);